;RaGrid wrapper 2.0.1.5-0.9
;By majkinetor

RG_ScrollCell(hGrd){
	static GM_SCROLLCELL=0x413	;wParam=0, lParam=0
	SendMessage,GM_SCROLLCELL,,,, ahk_id %hGrd% 
	return ErrorLevel
}

RG_ResetColumns(hGrd){
	static GM_RESETCOLUMNS=0x429	;wParam=0, lParam=0
	SendMessage,GM_RESETCOLUMNS,,,, ahk_id %hGrd% 
	return ErrorLevel
}

RG_GetHdrText(hGrd, nCol){
	static GM_GETHDRTEXT=0x424	;wParam=nCol, lParam=lpBuffer

	VarSetCapacity(txt, 128)
	SendMessage,GM_GETHDRTEXT,nCol,&txt,, ahk_id %hGrd% 
	return txt 
}

RG_SetHdrText(hGrd, nCol, txt=""){
	static GM_SETHDRTEXT=0x425	;wParam=nCol, lParam=lpBuffer

	SendMessage,GM_SETHDRTEXT,nCol,&txt,, ahk_id %hGrd% 
	return ErrorLevel
}

;wParam=nRow, lParam=lpROWDATA (can be NULL)
RG_AddRow(hGrd, aColName, nRow=""){ 
	local RAW, colCount 
	static GM_ADDROW=0x402, GM_INSROW=0x403

	colCount := RG_GetColCount(hGrd)

	VarSetCapacity(RAW, 4 * colCount, 0) 
	Loop %colCount% 
	  InsertInteger(&%aColName%%A_Index%, RAW, (A_Index - 1) * 4) 
	
	if (nRow = "")
			SendMessage,GM_ADDROW,0,&RAW,, ahk_id %hGrd% 
	else	SendMessage,GM_INSROW,nRow,&RAW,, ahk_id %hGrd%  
	return ErrorLevel 
}

RG_DelRow(hGrd, nRow=0) {
	static GM_DELROW=0x404		;wParam=nRow, lParam=0

	if nRow = -1
		nRow += RG_GetRowCount(hGrd)

	SendMessage,GM_DELROW,nRow,0,, ahk_id %hGrd% 
	return ErrorLevel 
}

RG_MoveRow(hGrd, pFrom, pTo ){
	static GM_MOVEROW=0x405
	SendMessage,GM_MOVEROW,pFrom,pTo,, ahk_id %hGrd% 
	return ErrorLevel 
}

RG_GetRowCount(hGrd) {
	static GM_GETROWCOUNT=0x40F		;wParam=0, lParam=0
	SendMessage,GM_GETROWCOUNT,0,0,, ahk_id %hGrd% 
	return ErrorLevel 
}

RG_GetColCount(hGrd) {
	static GM_GETCOLCOUNT=0x40E		;wParam=0, lParam=0
	SendMessage,GM_GETCOLCOUNT,0,0,, ahk_id %hGrd% 
	return ErrorLevel 
}

RG_GetColWidth(hGrd, nCol=0) {		;wParam=nCol, lParam=0
	static GM_GETCOLWIDTH=0x41C
	SendMessage,GM_GETCOLWIDTH,nCol,0,, ahk_id %hGrd% 
	return ErrorLevel 
}

RG_SetColWidth(hGrd, nCol, nWidth) {		;wParam=nCol, lParam=nWidth
	static GM_GETCOLWIDTH=0x41D
	SendMessage,GM_GETCOLWIDTH,nCol,nWidth,, ahk_id %hGrd% 
	return ErrorLevel 
}

RG_GetHdrHeight(hGrd) {		
	static GM_GETHDRHEIGHT=0x41E
	SendMessage,GM_GETHDRHEIGHT,0,0,, ahk_id %hGrd% 
	return ErrorLevel 
}

RG_SetHdrHeight(hGrd, h){
	static GM_SETHDRHEIGHT=0x41F
	SendMessage,GM_SETHDRHEIGHT,0,h,, ahk_id %hGrd%
	return ErrorLevel
}

RG_GetRowHeight(hGrd){		
	static GM_GETROWHEIGHT=0x420
	SendMessage,GM_GETROWHEIGHT,0,0,, ahk_id %hGrd%
	return ErrorLevel
}

RG_SetRowHeight(hGrd, nHeight){		
	static GM_SETROWHEIGHT=0x421
	SendMessage,GM_SETROWHEIGHT,0, nHeight,, ahk_id %hGrd%
	return ErrorLevel
}

RG_ResetContent(hGrd) {
	static GM_RESETCONTENT=0x422
	SendMessage,GM_RESETCONTENT,0,0,, ahk_id %hGrd%
	return ErrorLevel
}
	
RG_GetCurRow(hGrd) {
	static GM_GETCURROW=0x40C
	SendMessage,GM_GETCURROW,0,0,, ahk_id %hGrd% 
	return ErrorLevel 
}

RG_SetCurRow(hGrd, nRow=0) {		;wParam=nRow, lParam=0
	static GM_SETCURROW=0x40D
	SendMessage,GM_SETCURROW,nRow,0,, ahk_id %hGrd% 
	return ErrorLevel 
}

RG_EnterEdit(hGrd, nCol=0, nRow=0) {
	static GM_ENTEREDIT=0x41A	;wParam=nCol, lParam=nRow
	SendMessage, GM_ENTEREDIT,nCol,nRow,, ahk_id %hGrd% 
	return ErrorLevel 
}

RG_Sort(hGrd, col=0, type="ASC"){
	static GM_COLUMNSORT=0x423
	static ASC=0,DES=1,INVERT=2
	type := 0
	SendMessage,GM_COLUMNSORT,col,&type,,ahk_id %hGrd%
}

;-----------------------------------------------------------------------------------------------------------
;w		-colwt			;column width
;cap	-lpszhdrtext	;column captin
;ha		-halign			;Header text alignment.
;ca		-calign			;Column text alignment.
;maxt	-ctextmax		;Max text lenght for TYPE_EDITTEXT and TYPE_EDITLONG.
;type	-ctype			;type of data 
;						EDITTEXT,	EDITLONG,	CHECKBOX,	COMBOBOX,	HOTKEY,	BUTTON,	IMAGE,	DATE,	TIME,	USER,	EDITBUTTON
;sort	-hdrflag		;Header flags. Set to ZERO or if initially sorted set to initial sort direction
;						ASC, DES, INVERT
RG_AddColumn(hGrd, o1="", o2="", o3="", o4="", o5="", o6="", o7=""){
	local j, prop, COL
	
	;custom interface
	local w, cap, ha, ca, type, maxt, sort ; il
	;types
	static EDITTEXT=0,EDITLONG=1,CHECKBOX=2,COMBOBOX=3,HOTKEY=4,BUTTON=5,IMAGE=6,DATE=7,TIME=8,USER=9,EDITBUTTON=10
	;sort
	static ASC=0,DES=1,INVERT=2

	static GM_ADDCOL = 0x401

	type := "EDITTEXT"
	loop, 6 {
		if !o%A_index%
			continue

		j := InStr( o%A_index%, "=" )
		prop := SubStr(	o%A_index%, 1, j-1 )
		%prop% := SubStr( o%A_index%, j+1, 100)
	}
	
	type := %TYPE%, sort := %SORT%
	VarSetCapacity(COL, 48, 0)
	InsertInteger(w,		COL, 0)
	InsertInteger(&cap,		COL, 4)
	InsertInteger(ha,		COL, 8)
	InsertInteger(ca,		COL, 12)
	InsertInteger(type,		COL, 16)
	InsertInteger(maxt,		COL, 20)
;	InsertInteger(format,	COL, 24)	;not used now
;	InsertInteger(il,		COL, 28)	;NOT USED NOW
	InsertInteger(sort,		COL, 32)
	
	SendMessage,GM_ADDCOL,0, &col,, ahk_id %hGrd%
	return ErrorLevel
}

;Styles: NOSEL, NOFOCUS, HGRIDLINES, VGRIDLINES,GRIDLINES, GRIDFRAME, NOCOLSIZE
RG_Add(hwnd,x=0,y=0,w=200,h=100,style=""){
	static	WS_CLIPCHILDREN=0x2000000, WS_VISIBLE=0x10000000, WS_CHILD=0x40000000
	static	NOSEL=0x1, NOFOCUS=0x2, HGRIDLINES=0x4,VGRIDLINES=0x8,GRIDLINES=12, GRIDFRAME=0x10, NOCOLSIZE=0x20

	hexStyle := 0
	loop, parse, style, %A_Tab%%A_Space%
		hexStyle |= %A_LOOPFIELD%


	hModule := DllCall("LoadLibrary", "str", "dll\RAGrid.dll")
	hCtrl := DllCall("CreateWindowEx"
      , "Uint", 0x200            ; WS_EX_CLIENTEDGE
      , "str",  "RAGrid"         ; ClassName
      , "str",  szAppName        ; WindowName
      , "Uint", WS_CLIPCHILDREN | WS_CHILD | WS_VISIBLE | hexStyle
      , "int",  x            ; Left
      , "int",  y            ; Top
      , "int",  w            ; Width
      , "int",  h            ; Height
      , "Uint", hwnd         ; hWndParent
      , "Uint", 0            ; hMenu
      , "Uint", 0            ; hInstance
      , "Uint", 0)


	return hCtrl
}

;--------------------------------------------------------------------------------------------
; B - back color
; G - grid color
; T - text color
RG_SetColors(hGrd, colors){
	static GM_SETBACKCOLOR=0x415, GM_SETGRIDCOLOR=0x417, GM_SETTEXTCOLOR=0x419

	Loop, Parse, colors, %A_Space%
	{
		if A_LoopField =
			continue

		StringLeft c, A_LoopField, 1
		StringTrimLeft token, A_LoopField, 1
		
		%c% := "0x" token
	}


	if (B)
		SendMessage,GM_SETBACKCOLOR,B,,, ahk_id %hGrd%
	
	if (G)
 		SendMessage,GM_SETGRIDCOLOR,G,,, ahk_id %hGrd%

	if (T)
		SendMessage,GM_SETTEXTCOLOR,T,,, ahk_id %hGrd%
	
}

RG_GetColors(hGrd){
	static GM_GETBACKCOLOR=0x414, GM_GETGRIDCOLOR=0x416, GM_GETTEXTCOLOR=0x418

	oldFormat = A_FormatInteger
	SetFormat, integer, hex

	SendMessage,GM_GETBACKCOLOR,,,, ahk_id %hGrd%
	res .= "B" ERRORLEVEL
	SendMessage,GM_GETGRIDCOLOR,,,, ahk_id %hGrd%
	res .= " G" ERRORLEVEL
	SendMessage,GM_GETTEXTCOLOR,,,, ahk_id %hGrd%
	res .= " T" ERRORLEVEL

	SetFormat, integer, %oldFormat%
	return res
}

RG_SetFont(hGrd, pFont="") { 
   local height, weight, italic, underline, strikeout , nCharSet, fontFace, LogPixels
   local hFont
   static WM_SETFONT := 0x30


 ;parse font 
   italic      := InStr(pFont, "italic")    ?  1    :  0 
   underline   := InStr(pFont, "underline") ?  1    :  0 
   strikeout   := InStr(pFont, "strikeout") ?  1    :  0 
   weight      := InStr(pFont, "bold")      ? 700   : 400 

 ;height 
   RegExMatch(pFont, "(?<=[S|s])(\d{1,2})(?=[ ,])", height) 
   if (height = "") 
      height := 10 
   RegRead, LogPixels, HKEY_LOCAL_MACHINE, SOFTWARE\Microsoft\Windows NT\CurrentVersion\FontDPI, LogPixels 
   height := -DllCall("MulDiv", "int", Height, "int", LogPixels, "int", 72) 

 ;face 
   RegExMatch(pFont, "(?<=,).+", fontFace)    
   if (fontFace != "") 
       fontFace := RegExReplace( fontFace, "(^\s*)|(\s*$)")      ;trim 
   else fontFace := "MS Sans Serif" 

 ;create font 
   hFont   := DllCall("CreateFont", "int",  height, "int",  0, "int",  0, "int", 0 
                      ,"int",  weight,   "Uint", italic,   "Uint", underline 
                      ,"uint", strikeOut, "Uint", nCharSet, "Uint", 0, "Uint", 0, "Uint", 0, "Uint", 0, "str", fontFace) 

   SendMessage,WM_SETFONT,hFont,TRUE,,ahk_id %hGrd%
   return ErrorLevel
}

RG_ComboAddString(hGrd, nCol, string) {
	static GM_COMBOADDSTRING=0x406	;wParam=nCol, lParam=lpszString

	loop, parse, string, |
	{
		s := A_LoopField
		SendMessage, GM_COMBOADDSTRING, nCol, &s,, ahk_id %hGrd%
	}
}

RG_ComboClear(hGrd, nCol) {
	static GM_COMBOCLEAR=0x407	;wParam=nCol, lParam=0

	SendMessage, GM_COMBOCLEAR, nCol,,, ahk_id %hGrd%
	return ErrorLevel
}

RG_GetCellText(hGrd, nRow=0, nCol=0) {
	static GM_GETCELLDATA=0x410		;wParam=nRowCol, lParam=lpData
	
	VarSetCapacity(buf, 256, 0)

	nRowCol := (nRow << 16) + nCol
	SendMessage, GM_GETCELLDATA, nRowCol, &buf,, ahk_id %hGrd%
	return buf
}

RG_GetCellNum(hGrd, nRow=0, nCol=0) {
	static GM_GETCELLDATA=0x410		;wParam=nRowCol, lParam=lpData
	
	VarSetCapacity(buf, 256, 0)

	nRowCol := (nRow << 16) + nCol
	SendMessage, GM_GETCELLDATA, nRowCol, &buf,, ahk_id %hGrd%
	return ExtractInteger(buf)
}

;numeric values are for combo and checkbox (index of element)
RG_SetCellText(hGrd, nRow=0, nCol=0, data="") {
	static GM_SETCELLDATA=0x411		;wParam=nRowCol, lParam=lpData (can be NULL)
	
	if (numeric) {
		num := data
		VarSetCapacity(data, 4)
		InsertInteger(num, data, 0)
	}

	nRowCol := (nRow << 16) + nCol
	SendMessage, GM_SETCELLDATA, nRowCol, &data,, ahk_id %hGrd%
	return ERRORLEVEL
}

RG_SetCellNum(hGrd, nRow=0, nCol=0, num=0) {
	static GM_SETCELLDATA=0x411		;wParam=nRowCol, lParam=lpData (can be NULL)
	
	VarSetCapacity(data, 4)
	InsertInteger(num, data, 0)

	nRowCol := (nRow << 16) + nCol
	SendMessage, GM_SETCELLDATA, nRowCol, &data,, ahk_id %hGrd%
	return ERRORLEVEL
}

RG_GetCurSel(hGrd, ByRef nRow, ByRef nCol) {
	static GM_GETCURSEL=0x408	

	SendMessage, GM_GETCURSEL,,,, ahk_id %hGrd%
	nRow := ErrorLevel >> 16
	nCol := ErrorLevel & 0x00001111
}

RG_SetCurSel(hGrd, nCol=0, nRow=0) {	;wParam=nCol, lParam=nRow
	static GM_SETCURSEL=0x409

	SendMessage, GM_SETCURSEL,nCol,nRow,, ahk_id %hGrd%
	return ERRORLEVEL
}

RG_GetCurCol(hGrd) {	
	static GM_GETCURCOL=0x40A

	SendMessage, GM_GETCURCOL,,,, ahk_id %hGrd%
	return ERRORLEVEL
}

RG_SetCurCol(hGrd, nCol=0) {				;wParam=nCol, lParam=0
	static GM_SETCURCOL=0x40B

	SendMessage, GM_SETCURCOL,nCol,,,ahk_id %hGrd%
	return ERRORLEVEL
}

RG_SetRowColor(hGrd, back, text, nRow=0) {				;wParam=nRow, lParam=lpROWCOLOR
	static GM_SETROWCOLOR=0x42B

	VarSetCapacity(RC, 8)
	InsertInteger(back, RC, 0)
	InsertInteger(text, RC, 4)
	
	SendMessage, GM_SETROWCOLOR, nRow, &RC,,ahk_id %hGrd%
	return ERRORLEVEL
}

RG_GetRowColor(hGrd, back, text, nRow=0) {				;wParam=nRow, lParam=lpROWCOLOR
	static GM_GETROWCOLOR=0x42C

	VarSetCapacity(RC, 8)
	SendMessage, GM_GETROWCOLOR, nRow, &RC,,ahk_id %hGrd%
	return "not wrapped"	
}

RG_About(var=""){
	static ver := "2.0.1.5-0.9"
	if (var="version")
		msg := ver
	else {
		msg := "RaGrid  " ver  "`n"
		msg .= "By KetilO <www.radasm.com>`n`n"
		msg .= "AHK wrapper by majkinetor"
	}
	return msg
}