;###############################################################################
/* CheckBox for LilBuilder

*/
;###############################################################################

CheckBox_CreateMenu(Menu_CheckBox){
  MMenu_Add(Menu_CheckBox, "set left","","","iCommonMenu_SetLeft")
  MMenu_Add(Menu_CheckBox, "set right","","","iCommonMenu_SetRight")
  MMenu_Add(Menu_CheckBox, "Check","","","iCheckBox_SetChecked")
}

CheckBox_ShowMenu:
  CommonMenu_UpdateMenu(Menu_CheckBox)
  CheckBox_UpdateMenu(Menu_CheckBox)
  MMenu_Show(Menu_CheckBox, Menu_vX(), Menu_vY(), "CheckBox_OnSelection")
Return

CheckBox_OnSelection:
  If RegExMatch(MMenu_ID, "^CommonMenu_Set(Left|Right|Center)$")
    CommonMenu_SetLeftRightCenter(Menu_vGuiHWND(), Menu_vCtrlHWND(), SubStr(MMenu_ID,15))
  Else If MMenu_ID = CheckBox_SetChecked
    CheckBox_SetChecked(Menu_vGuiHWND(), Menu_vCtrlHWND())
  Else If IsLabel(MMenu_ID)
    GoSub, %MMenu_ID%
Return

;###############################################################################

CheckBox_UpdateMenu(hMenu){
  CtrlHWND := Menu_vCtrlHWND()
  Checked := Control(CtrlHWND,"Checked")
  CheckStatus := Checked ? "+c" : "-c"
  Text := Checked ? "Checked" : "Check"
  MMenu_Set(hMenu,"CheckBox_SetChecked", Text,"", CheckStatus)
}

CheckBox_SetChecked(GuiHWND, CtrlHWND){
  GuiID := Gui(GuiHWND, "GuiID")
  CtrlID := Control(CtrlHWND, "VarName")
  Checked := !Control(CtrlHWND,"Checked")
  GuiControl, %GuiID%:, %CtrlID%, %Checked%
  Control(CtrlHWND,"Checked", Checked)
}
