;###############################################################################
/* TrayMenu for LilBuilder

*/
;###############################################################################

TrayMenu_CreateTrayMenu(){
;   Menu, Tray, Icon, % g("IconFile"), 14   ;icon for taskbar and for process in task manager
;   TrayMenu_Tip(g("ScriptName"))
 
  Menu, Tray, NoStandard

  TrayMenu_CreateTrayAbout()
  Menu, Tray, Add, About Modules, :AboutModules
  Menu, Tray, Add, Reload, TrayMenu_Reload
  Menu, Tray, Add, Exit, LilBuilder_OnExit
  Menu, Tray, Click, 1
}

TrayMenu_SetTrayTip(Text){
    Menu, Tray, Tip, %Text%
  }

TrayMenu_Reload:
  Reload
Return

TrayMenu_CreateTrayAbout() {
	Menu, AboutModules, Add, Anchor, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, Dic, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, Dock, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, IniSettingsEditor, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, MMenu, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, PGUI, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, RelativePath, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, Tooltip, TrayMenu_OnModuleAbout

	Menu, AboutModules, Add
	Menu, AboutModules, Add, HiEdit, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, RaGrid, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, HLink, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, SpreadSheet, TrayMenu_OnModuleAbout
	Menu, AboutModules, Add, WebControl, TrayMenu_OnModuleAbout
}

TrayMenu_OnModuleAbout( pItem ) {
	;this and tray menu creation can be automated if all modules contain function About()

;   return Call(pItem "_About")  ;Doesn't work, since Call only returns numbers

  If pItem=Anchor
		Return Anchor_About()
	Else If pItem=Dic
		Return Dic_About()
	Else If pItem=Dock
		Return Dock_About()
	Else If pItem=IniSettingsEditor
		Return IniSettingsEditor_About()
	Else If pItem=MMenu
		Return MMenu_About()
; 	Else If pItem=PGUI
; 		Return PGUI_About()
	Else If pItem=RelativePath
		Return RelativePath_About()
	Else If pItem=Tooltip
		Return Tooltip_About()
; 	Else If pItem=HiEdit
; 		Return HiEdit_About()
 	Else If pItem=RaGrid
 		Return RG_About()
; 	Else If pItem=HLink
; 		Return HLink_About()
; 	Else If pItem=SpreadSheet
; 		Return SpreadSheet_About()
; 	Else If pItem=WebControl
; 		Return WebControl_About()

	return pItem " version ??, created by ??`nThe module is missing an About() function."
}

TrayMenu_OnModuleAbout:
	MsgBox, 64, About module %A_ThisMenuItem%, % TrayMenu_OnModuleAbout(A_ThisMenuItem)
return

